(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('ramda')) :
	typeof define === 'function' && define.amd ? define('react-style-hoc', ['exports', 'ramda'], factory) :
	(factory((global.Style = global.Style || {}),global.ramda));
}(this, (function (exports,ramda) { 'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};



















var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};













var objectWithoutProperties = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};





















var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var generateStyleObject = function generateStyleObject(style, value) {

  // it's a style object with defaults
  if ((typeof style === 'undefined' ? 'undefined' : _typeof(style)) === 'object' && !Array.isArray(style)) {
    return style;
  }

  // just an array with style keys
  if (Array.isArray(style)) {
    return Object.assign.apply(Object, toConsumableArray(style.map(function (key) {
      return defineProperty({}, key, value);
    })));
  }

  // a style key string
  return Object.assign(defineProperty({}, style, value));
};

var createStyleHoc = ramda.curry(function (style, value, WrappedComponentOrStyle) {
  // style -> e.g. { margin: 10, padding: 30 } || ['margin', 'padding'] || 'margin'
  // we should support default styles, an array of style values to be added, or one string.

  var newStyleObject = generateStyleObject(style, value);

  /**
  |--------------------------------------------------
  | how can we detect is a component has been passed through,
  | and otherwise simply generate a style object? -- useful for
  | composing without having to depend on react.
  |--------------------------------------------------
  */

  return function (_ref2) {
    var style = _ref2.style,
        props = objectWithoutProperties(_ref2, ['style']);

    return WrappedComponentOrStyle(Object.assign({ style: _extends({}, newStyleObject, style) }, props));
  };
});

var withPadding = createStyleHoc('padding');

var withMargin = createStyleHoc('margin');

exports.withPadding = withPadding;
exports.withMargin = withMargin;
exports.createStyleHoc = createStyleHoc;
exports.compose = ramda.compose;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.js.map
